AuthenticatedSymmetricCipherBase Class Referenceabstract

Base implementation for one direction (encryption or decryption) of a stream cipher or block cipher mode with authentication. More...

Inheritance diagram for AuthenticatedSymmetricCipherBase:

## Public Member Functions

bool | IsRandomAccess () const
| Determines whether the cipher supports random access. More...
bool | IsSelfInverting () const
| Determines whether the cipher is self-inverting. More...
void | UncheckedSetKey (const byte *key, unsigned int length, const ::NameValuePairs &params)
| Sets the key for this object without performing parameter validation. More...
void | SetKey (const byte *userKey, size_t keylength, const NameValuePairs &params)
| Sets or reset the key of this object. More...
void | Restart ()
| Restart the hash. More...
void | Resynchronize (const byte *iv, int length=-1)
| Resynchronize with an IV. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
void | ProcessData (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt an array of bytes. More...
void | TruncatedFinal (byte *mac, size_t macSize)
| Computes the hash of the current message. More...
Public Member Functions inherited from AuthenticatedSymmetricCipher
virtual lword | MaxHeaderLength () const =0
| Provides the maximum length of AAD that can be input. More...
virtual lword | MaxMessageLength () const =0
| Provides the maximum length of encrypted data. More...
virtual lword | MaxFooterLength () const
| Provides the the maximum length of AAD. More...
virtual bool | NeedsPrespecifiedDataLengths () const
| Determines if data lengths must be specified prior to inputting data. More...
void | SpecifyDataLengths (lword headerLength, lword messageLength, lword footerLength=0)
| Prespecifies the data lengths. More...
virtual void | EncryptAndAuthenticate (byte *ciphertext, byte *mac, size_t macSize, const byte *iv, int ivLength, const byte *header, size_t headerLength, const byte *message, size_t messageLength)
| Encrypts and calculates a MAC in one call. More...
virtual bool | DecryptAndVerify (byte *message, const byte *mac, size_t macLength, const byte *iv, int ivLength, const byte *header, size_t headerLength, const byte *ciphertext, size_t ciphertextLength)
| Decrypts and verifies a MAC in one call. More...
virtual std::string | AlgorithmName () const =0
| Provides the name of this algorithm. More...
Public Member Functions inherited from SimpleKeyingInterface
virtual size_t | MinKeyLength () const =0
| Returns smallest valid key length in bytes.
virtual size_t | MaxKeyLength () const =0
| Returns largest valid key length in bytes.
virtual size_t | DefaultKeyLength () const =0
| Returns default (recommended) key length in bytes.
virtual size_t | GetValidKeyLength (size_t n) const =0
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length. More...
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
virtual IV_Requirement | IVRequirement () const =0
| Minimal requirement for secure IVs. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs returns whether the object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV), false otherwise.
virtual unsigned int | IVSize () const
| Returns length of the IV accepted by this object. More...
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
virtual unsigned int | DigestSize () const =0
| Provides the digest size of the hash. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object. More...
virtual unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size. More...
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
virtual void | ProcessLastBlock (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt the last block of data. More...
virtual unsigned int | MinLastBlockSize () const
| returns the minimum size of the last block, 0 indicating the last block is not special
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes. More...
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes. More...
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte. More...
virtual void | Seek (lword pos)
| Seek to an absolute position. More...
virtual bool | IsForwardTransformation () const =0
| Determines if the cipher is being operated in its forward direction. More...

## Additional Inherited Members

Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...

## Detailed Description

Base implementation for one direction (encryption or decryption) of a stream cipher or block cipher mode with authentication.

Since
  Crypto++ 5.6.0

Definition at line 19 of file authenc.h.

## Member Function Documentation

## IsRandomAccess()

bool AuthenticatedSymmetricCipherBase::IsRandomAccess | ( |  | ) | const

inline virtual

Determines whether the cipher supports random access.

Returns
  true if the cipher supports random access, false otherwise

Implements StreamTransformation.

Definition at line 25 of file authenc.h.

## IsSelfInverting()

bool AuthenticatedSymmetricCipherBase::IsSelfInverting | ( |  | ) | const

inline virtual

Determines whether the cipher is self-inverting.

Returns
  true if the cipher is self-inverting, false otherwise

IsSelfInverting determines whether this transformation is self-inverting (e.g. xor with a keystream).

Implements StreamTransformation.

Definition at line 26 of file authenc.h.

## UncheckedSetKey()

void AuthenticatedSymmetricCipherBase::UncheckedSetKey | ( | const byte * | key,
|  | unsigned int | length,
|  | const ::NameValuePairs & | params
| ) |  |

inline

Sets the key for this object without performing parameter validation.

Parameters

  key | a byte buffer used to key the cipher
  length | the length of the byte buffer
  params | additional parameters passed as NameValuePairs

key must be at least DEFAULT_KEYLENGTH in length.

Definition at line 33 of file authenc.h.

## SetKey()

void AuthenticatedSymmetricCipherBase::SetKey | ( | const byte * | key,
|  | size_t | length,
|  | const NameValuePairs & | params
| ) |  |

virtual

Sets or reset the key of this object.

Parameters

  key | the key to use when keying the object
  length | the size of the key, in bytes
  params | additional initialization parameters that cannot be passed directly through the constructor

Reimplemented from SimpleKeyingInterface.

Definition at line 48 of file authenc.cpp.

## Restart()

void AuthenticatedSymmetricCipherBase::Restart | ( |  | ) |

inline virtual

Restart the hash.

Discards the current state, and restart for a new message

Reimplemented from HashTransformation.

Definition at line 37 of file authenc.h.

## Resynchronize()

void AuthenticatedSymmetricCipherBase::Resynchronize | ( | const byte * | iv,
|  | int | ivLength = `-1`
| ) |  |

virtual

Resynchronize with an IV.

Parameters

  iv | the initialization vector
  ivLength | the size of the initialization vector, in bytes

Resynchronize() resynchronizes with an IV provided by the caller. `ivLength=-1` means use IVSize().

Exceptions

  NotImplemented() | if the object does not support resynchronization

Reimplemented from SimpleKeyingInterface.

Definition at line 62 of file authenc.cpp.

## Update()

void AuthenticatedSymmetricCipherBase::Update | ( | const byte * | input,
|  | size_t | length
| ) |  |

virtual

Updates a hash with additional input.

Parameters

  input | the additional input as a buffer
  length | the size of the buffer, in bytes

Implements HashTransformation.

Definition at line 75 of file authenc.cpp.

## ProcessData()

void AuthenticatedSymmetricCipherBase::ProcessData | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length
| ) |  |

virtual

Encrypt or decrypt an array of bytes.

Parameters

  outString | the output byte buffer
  inString | the input byte buffer
  length | the size of the input and output byte buffers, in bytes

Either `inString == outString`, or they must not overlap.

Implements StreamTransformation.

Definition at line 104 of file authenc.cpp.

## TruncatedFinal()

void AuthenticatedSymmetricCipherBase::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize
| ) |  |

virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() call Final() and then copies digestSize bytes to digest

TruncatedFinal() restarts the hash for the next message.

Precondition
  `COUNTOF(digest) == DigestSize()` or `COUNTOF(digest) == HASH::DIGESTSIZE` ensures the output byte buffer is large enough for the digest.

Implements HashTransformation.

Definition at line 136 of file authenc.cpp.

The documentation for this class was generated from the following files:

- authenc.h
- authenc.cpp